/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.DsrStepsMonitoringRecord;

import java.sql.Timestamp;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class DsrStepsMonitoring extends TableImpl<DsrStepsMonitoringRecord> {

    private static final long serialVersionUID = -1771921645;

    /**
     * The reference instance of <code>DSR_STEPS_MONITORING</code>
     */
    public static final DsrStepsMonitoring DSR_STEPS_MONITORING = new DsrStepsMonitoring();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<DsrStepsMonitoringRecord> getRecordType() {
        return DsrStepsMonitoringRecord.class;
    }

    /**
     * The column <code>DSR_STEPS_MONITORING.IDDSR</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, String> IDDSR = createField("IDDSR", org.jooq.impl.SQLDataType.VARCHAR(512).nullable(false), this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.LAST_UPDATE</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> LAST_UPDATE = createField("LAST_UPDATE", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaultValue(org.jooq.impl.DSL.field("CURRENT_TIMESTAMP(3)", org.jooq.impl.SQLDataType.TIMESTAMP)), this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.EXTRACT_QUEUED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> EXTRACT_QUEUED = createField("EXTRACT_QUEUED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.EXTRACT_STARTED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> EXTRACT_STARTED = createField("EXTRACT_STARTED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.EXTRACT_FINISHED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> EXTRACT_FINISHED = createField("EXTRACT_FINISHED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.EXTRACT_STATUS</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, String> EXTRACT_STATUS = createField("EXTRACT_STATUS", org.jooq.impl.SQLDataType.VARCHAR(10), this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.PRICE_QUEUED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> PRICE_QUEUED = createField("PRICE_QUEUED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.PRICE_STARTED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> PRICE_STARTED = createField("PRICE_STARTED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.PRICE_FINISHED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> PRICE_FINISHED = createField("PRICE_FINISHED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.PRICE_STATUS</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, String> PRICE_STATUS = createField("PRICE_STATUS", org.jooq.impl.SQLDataType.VARCHAR(10), this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.HYPERCUBE_QUEUED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> HYPERCUBE_QUEUED = createField("HYPERCUBE_QUEUED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.HYPERCUBE_STARTED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> HYPERCUBE_STARTED = createField("HYPERCUBE_STARTED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.HYPERCUBE_FINISHED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> HYPERCUBE_FINISHED = createField("HYPERCUBE_FINISHED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.HYPERCUBE_STATUS</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, String> HYPERCUBE_STATUS = createField("HYPERCUBE_STATUS", org.jooq.impl.SQLDataType.VARCHAR(10), this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.IDENTIFY_QUEUED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> IDENTIFY_QUEUED = createField("IDENTIFY_QUEUED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.IDENTIFY_STARTED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> IDENTIFY_STARTED = createField("IDENTIFY_STARTED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.IDENTIFY_FINISHED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> IDENTIFY_FINISHED = createField("IDENTIFY_FINISHED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.IDENTIFY_STATUS</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, String> IDENTIFY_STATUS = createField("IDENTIFY_STATUS", org.jooq.impl.SQLDataType.VARCHAR(10), this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.UNILOAD_QUEUED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> UNILOAD_QUEUED = createField("UNILOAD_QUEUED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.UNILOAD_STARTED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> UNILOAD_STARTED = createField("UNILOAD_STARTED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.UNILOAD_FINISHED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> UNILOAD_FINISHED = createField("UNILOAD_FINISHED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.UNILOAD_STATUS</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, String> UNILOAD_STATUS = createField("UNILOAD_STATUS", org.jooq.impl.SQLDataType.VARCHAR(10), this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.CLAIM_QUEUED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> CLAIM_QUEUED = createField("CLAIM_QUEUED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.CLAIM_STARTED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> CLAIM_STARTED = createField("CLAIM_STARTED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.CLAIM_FINISHED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> CLAIM_FINISHED = createField("CLAIM_FINISHED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.CLAIM_STATUS</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, String> CLAIM_STATUS = createField("CLAIM_STATUS", org.jooq.impl.SQLDataType.VARCHAR(10), this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.PRELEARN_QUEUED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> PRELEARN_QUEUED = createField("PRELEARN_QUEUED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.PRELEARN_STARTED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> PRELEARN_STARTED = createField("PRELEARN_STARTED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.PRELEARN_FINISHED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> PRELEARN_FINISHED = createField("PRELEARN_FINISHED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.PRELEARN_STATUS</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, String> PRELEARN_STATUS = createField("PRELEARN_STATUS", org.jooq.impl.SQLDataType.VARCHAR(10), this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.LEARN_QUEUED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> LEARN_QUEUED = createField("LEARN_QUEUED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.LEARN_STARTED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> LEARN_STARTED = createField("LEARN_STARTED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.LEARN_FINISHED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> LEARN_FINISHED = createField("LEARN_FINISHED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.LEARN_STATUS</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, String> LEARN_STATUS = createField("LEARN_STATUS", org.jooq.impl.SQLDataType.VARCHAR(10), this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.CLEAN_QUEUED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> CLEAN_QUEUED = createField("CLEAN_QUEUED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.CLEAN_STARTED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> CLEAN_STARTED = createField("CLEAN_STARTED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.CLEAN_FINISHED</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, Timestamp> CLEAN_FINISHED = createField("CLEAN_FINISHED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>DSR_STEPS_MONITORING.CLEAN_STATUS</code>.
     */
    public final TableField<DsrStepsMonitoringRecord, String> CLEAN_STATUS = createField("CLEAN_STATUS", org.jooq.impl.SQLDataType.VARCHAR(10), this, "");

    /**
     * Create a <code>DSR_STEPS_MONITORING</code> table reference
     */
    public DsrStepsMonitoring() {
        this(DSL.name("DSR_STEPS_MONITORING"), null);
    }

    /**
     * Create an aliased <code>DSR_STEPS_MONITORING</code> table reference
     */
    public DsrStepsMonitoring(String alias) {
        this(DSL.name(alias), DSR_STEPS_MONITORING);
    }

    /**
     * Create an aliased <code>DSR_STEPS_MONITORING</code> table reference
     */
    public DsrStepsMonitoring(Name alias) {
        this(alias, DSR_STEPS_MONITORING);
    }

    private DsrStepsMonitoring(Name alias, Table<DsrStepsMonitoringRecord> aliased) {
        this(alias, aliased, null);
    }

    private DsrStepsMonitoring(Name alias, Table<DsrStepsMonitoringRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> DsrStepsMonitoring(Table<O> child, ForeignKey<O, DsrStepsMonitoringRecord> key) {
        super(child, key, DSR_STEPS_MONITORING);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.DSR_STEPS_MONITORING_DSR_STEPS_MONITORING_IDX_01, Indexes.DSR_STEPS_MONITORING_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<DsrStepsMonitoringRecord> getPrimaryKey() {
        return Keys.KEY_DSR_STEPS_MONITORING_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<DsrStepsMonitoringRecord>> getKeys() {
        return Arrays.<UniqueKey<DsrStepsMonitoringRecord>>asList(Keys.KEY_DSR_STEPS_MONITORING_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrStepsMonitoring as(String alias) {
        return new DsrStepsMonitoring(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrStepsMonitoring as(Name alias) {
        return new DsrStepsMonitoring(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public DsrStepsMonitoring rename(String name) {
        return new DsrStepsMonitoring(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public DsrStepsMonitoring rename(Name name) {
        return new DsrStepsMonitoring(name, null);
    }
}
